#include <stdlib.h>
#define _GNU_SOURCE
#include <stdio.h>
#include <string.h>
#include "el_type.h"

struct node
{
	el_type element;         //,   
	struct node *next;       //   
};
     
typedef struct node node;    //      struct node

node *push(node *stack, el_type element);
el_type pop(node **pstack);
el_type peek(node *stack);
int count(node *stack);
node *invert(node *stack);
char *print_down(node *stack, char *string, int max_size,
                 char *(*print_element) (el_type element));
char *print_up(node *stack, char *(*print_element) (el_type element));
